#include "plugin.h"

#include <iostream>
#include <string>
#include <map>

extern "C" {

class MyPlugin : public CppPlugin {
public:
    virtual void onLoad();
    virtual void onEnable();
    virtual void onDisable();
    virtual std::map<std::string, eventfptr> getEvents();
};

void MyPlugin::onLoad() {
	std::cout << "onload();" << std::endl;
}

void MyPlugin::onEnable() {
	std::cout << "onEnable();" << std::endl;
}

void MyPlugin::onDisable() {
	std::cout << "onDisable();" << std::endl;
}

CppPlugin* init() {
    std::cout << "init im plugin!" << std::endl;
    return new MyPlugin();
}

void eventJoin(JNIEnv* env, CppPlugin* pl, Event* e) {
	jstring msg = (jstring) e->getData(env, "joinMessage");
	std::string jmsg(env->GetStringUTFChars(msg, 0));
	std::cout << "join " << e->getName() << " old join message: " << jmsg << std::endl;
	jstring newmsg = env->NewStringUTF("Ein Spieler ist dem Spiel beigetreten!");
	e->setData("joinMessage", newmsg);
}

void eventQuit(JNIEnv* env, CppPlugin* pl, Event* e) {
	std::cout << "quit " << e->getName() << std::endl;
}

std::map<std::string, eventfptr> MyPlugin::getEvents() {
	std::cout << "MyPlugin::getEvents" << std::endl;
	std::map<std::string, eventfptr> out;
	out.insert({"PlayerJoinEvent", eventJoin});
	out.insert({"PlayerQuitEvent", eventQuit});
	return out;
}

}//extern "C"